
uniform mat4 mWorldViewProj;
uniform mat4 mInvWorld;
uniform mat4 mTransWorld;
//uniform vec3 mLightPos;
//uniform vec4 mLightColor;

uniform vec3 mLensPos;

void main(void)
{
	float lens_r = 3.0;
	float lens_magnify = 1.96;
	float amount = mLensPos.z;

	//vec4 pos = mWorldViewProj * gl_Vertex;
	vec4 lensPos = vec4(mLensPos.xy, 0.0, 0.0);
	vec4 pos = gl_Vertex;
	vec4 lens = pos - lensPos / 2.0;
	float dsq = lens.x * lens.x + lens.y * lens.y;
	float z = sqrt(abs(lens_r * lens_r - lens.x * lens.x - lens.y * lens.y));
	//if (dsq < lens_r * lens_r)
	{
		lens = lens * (1.0 - amount) + amount * lens * lens_magnify / z;
	}
//	else
//	{
//		lens.y = lens.y + 10000.0 * amount;
//	}
	pos = lens + lensPos / 2.0;
	pos = mWorldViewProj * pos;

	gl_Position = pos;
	gl_PointSize = 20.0 / gl_Position.z;

	vec4 normal = vec4(gl_Normal, 0.0);
	normal = mInvWorld * normal;
	normal = normalize(normal);

	//vec4 worldpos = gl_Vertex * mTransWorld;

	//vec4 lightVector = worldpos - vec4(mLightPos,1.0);
	//lightVector = normalize(lightVector);

	//float tmp2 = dot(-lightVector, normal);

	//vec4 tmp = mLightColor * tmp2;
	//gl_FrontColor = gl_BackColor = vec4(tmp.x, tmp.y, tmp.z, 0.0);
	gl_FrontColor = gl_BackColor = gl_Color;

	gl_TexCoord[0] = gl_MultiTexCoord0;
}
